package com.oferteo.api.v1.client.rest;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.json.JSONArray;
import org.json.JSONObject;

public class ApiDescRest
{
	private Map<String, String> cssPaths = new ConcurrentHashMap<String, String>();
	private Map<String, String> jsPaths = new ConcurrentHashMap<String, String>();

	protected ApiDescRest(JSONArray cssPathsJson, JSONArray jsPathsJson) 
	{
		if (cssPathsJson != null) {
			for (int i = 0; i < cssPathsJson.length(); i++) {
				JSONObject cssElement = cssPathsJson.getJSONObject(i);
				this.cssPaths.put(cssElement.getString("id"), cssElement.getString("value"));
			}
		}
		if (jsPathsJson != null) {
			for (int i = 0; i < jsPathsJson.length(); i++) {
				JSONObject jsElement = jsPathsJson.getJSONObject(i);
				this.cssPaths.put(jsElement.getString("id"), jsElement.getString("value"));
			}
		}
	}

	public ApiDescRest(JSONObject jsonObj) 
	{
			this(jsonObj.getJSONArray("cssPaths"), jsonObj.getJSONArray("jsPaths"));
	}

	Map<String, String> getCssPaths()
	{
		return cssPaths;
	}

	Map<String, String> getJsPaths()
	{
		return jsPaths;
	}
	
	
}
