package com.oferteo.api.v1.client.rest;

import java.util.Collection;

public class CategoriesHtmlBuilder extends HtmlBuilder 
{

	private Collection<CategoryRest> categoriesTree;
	private String urlPrefix;
	private String locationSelected;

	public CategoriesHtmlBuilder(Collection<CategoryRest> categoriesTree, String urlPrefix, String locationSelected) 
	{
		this.categoriesTree = categoriesTree;
		this.urlPrefix = urlPrefix;
		this.locationSelected = locationSelected;
	}

	public String getHtml() 
	{
		addCategories(this.categoriesTree);
		return getSb().toString();
	}
	
	protected void addCategories(Collection<CategoryRest> categories) 
	{
		openUl();
		for (CategoryRest category : categories) {
			boolean draw = true;
			if (draw) {
				openCatLocLi(category.isSelected(), category.isLeaf());
				StringBuilder sb = getSb();
				
				String url = getCategoryUrl(category);
				String cssClass = (category.isSelected() ? "a-selected" : null);
				openAnchor(cssClass, null, url, "idCat");
				sb.append(category.getName());
				closeAnchor();
				closeLi();

				if (!category.getSubcategories().isEmpty() && category.isSelected()) {
					addCategories(category.getSubcategories());
				}
			}
		}

		closeUl();
	}
	
	protected String getCategoryUrl(CategoryRest category) {
		return this.urlPrefix + category.getUrlCategory() + (locationSelected != null ? locationSelected : "");
	}
	
	protected Collection<CategoryRest> getCategoriesTree()
	{
		return categoriesTree;
	}

	protected String getUrlPrefix()
	{
		return urlPrefix;
	}

	protected String getLocationSelected()
	{
		return locationSelected;
	}
	
}
