package com.oferteo.api.v1.client.rest;

import java.util.ArrayList;
import java.util.Collection;

import org.json.JSONObject;

public class CategoryRest 
{

	private int 	id;
	private String 	name;
	private int 	idParent;
	private String 	urlCategory;
	private boolean leaf;
	private boolean selected;
	private Collection<CategoryRest> subcategories = new ArrayList<CategoryRest>();
	private CategoryRest parent;
	
	protected CategoryRest(int id, String name, int idParent, String urlCategory, boolean leaf, boolean selected) 
	{
		super();
		this.id = id;
		this.name = name;
		this.idParent = idParent;
		this.urlCategory = urlCategory;
		this.leaf = leaf;
		this.selected = selected;
	}

	public CategoryRest(JSONObject jsonObj) 
	{
			this(
				jsonObj.getInt("id"), 
				jsonObj.getString("name"), 
				jsonObj.getInt("idParent"), 
				jsonObj.getString("urlCategory"),
				jsonObj.getBoolean("leaf"),
				jsonObj.getBoolean("selected")
				);
	}

	public int getId() {
		return id;
	}

	public String getName() {
		return name;
	}

	public int getIdParent() {
		return idParent;
	}

	public String getUrlCategory() {
		return urlCategory;
	}

	public boolean isLeaf() {
		return leaf;
	}

	public boolean isSelected() {
		return selected;
	}

	public Collection<CategoryRest> getSubcategories() {
		return subcategories;
	}

	public CategoryRest getParent() {
		return parent;
	}

	public void setParent(CategoryRest parent) {
		this.parent = parent;
	}

	@Override
	public String toString() {
		return "CategoryRest [id=" + id + ", name=" + name + ", idParent="
				+ idParent + ", urlCategory=" + urlCategory + ", leaf=" + leaf + ", selected=" + selected
				+ ", subcategories=" + subcategories + "]";
	}
}
