package com.oferteo.api.v1.client.rest;

public class HtmlBuilder 
{
	
	private StringBuilder sb;
	
	HtmlBuilder() {
		this.sb = new StringBuilder();
	}
	
	protected StringBuilder getSb() {
		return this.sb;
	}

	protected void openLi() {
		openLi(null);
	}
	
	protected void openLi(String cssClass) {
		openLi(cssClass, null);
	}
	
	protected void openLi(String cssClass, String itemType) {
		if (cssClass != null && cssClass.length() > 0) {
			sb.append("<li class=\"" + cssClass + "\"");
		} else {
			sb.append("<li");
		}
		if (itemType != null && itemType.length() > 0) {
			sb.append(" itemtype=\"").append(itemType).append("\" itemscope=\"\"");
		}
		sb.append(">");
	}

	protected void openCatLocLi(boolean selected, boolean leaf) {
		String cssClass = "";
		if (selected) {
			cssClass += " cat-selected";
		}
		if (leaf) {
			cssClass += " cat-leaf";
		}
		if (cssClass.length() > 0) {
			sb.append("<li class=\"" + cssClass + "\">");
		} else {
			sb.append("<li>");
		}
	}

	protected void closeLi() {
		sb.append("</li>");
	}

	protected void openUl() {
		sb.append("<ul>");
	}

	protected void openUl(String cssClass) {
		sb.append("<ul class=\"").append(cssClass).append("\">");
	}

	protected void closeUl() {
		sb.append("</ul>");
	}
	
	protected void openDiv(String cssClass) {
		openDiv(cssClass, null);
	}
	
	private String getPropertyStr(String propertyName, String propertyValue) {
		String str = "";
		if (propertyValue != null && propertyValue.length() > 0) {
			str = " " + propertyName + "=\"" + propertyValue + "\"";
		}
		
		return str;
	}
	
	protected void openDiv(String cssClass, String title) {
		String classStr = getPropertyStr("class", cssClass);
		String titleStr = getPropertyStr("title", title);
		sb.append("<div").append(classStr).append(titleStr);
		sb.append(">");
	}

	protected void closeDiv() {
		sb.append("</div>");
	}

	protected void openAnchor(String cssClass, String title, String href) {
		openAnchor(cssClass, title, href, null);
	}
	
	protected void openAnchor(String cssClass, String title, String href, String id) {
		String cssClassStr = getPropertyStr("class", cssClass);
		String titleStr = getPropertyStr("title", title);
		String hrefStr = getPropertyStr("href", href);
		String idStr = "";
		if (id != null && !id.equals("")) {
			idStr = " id=\"" + id + "\"";
		}

		sb.append("<a").append(cssClassStr).append(titleStr).append(hrefStr).append(idStr).append(">");
	}

	protected void closeAnchor() {
		sb.append("</a>");
	}

	protected void addDivClear() {
		sb.append("<div class=\"clear\"></div>");
	}

	protected void openSpan(String cssStyle) {
		sb.append("<span class=\"").append(cssStyle).append("\">");
	}
	
	protected void openSpan() {
		sb.append("<span>");
	}
	
	protected void closeSpan() {
		sb.append("</span>");
	}
}
