package com.oferteo.api.v1.client.rest;

import java.util.ArrayList;
import java.util.Collection;

import org.json.JSONObject;

public class LocationRest 
{

	private String 	id;
	private String 	name;
	private String 	idGroup;
	private String	urlLocation;
	private int 	level;
	private boolean selected;
	private boolean leaf;
	private LocationRest parent;
	private Collection<LocationRest> locations = new ArrayList<LocationRest>();
	
	protected LocationRest(String id, String name, String idGroup, String urlLocation,
			int level, boolean selected, boolean leaf) 
	{
		super();
		this.id = id;
		this.name = name;
		this.idGroup = idGroup;
		this.urlLocation = urlLocation;
		this.level = level;
		this.selected = selected;
		this.leaf = leaf;
	}
	
	public LocationRest(JSONObject jsonObj) 
	{
		this(jsonObj.getString("id"), 
				jsonObj.getString("name"), 
				jsonObj.getString("idGroup"), 
				jsonObj.getString("urlLocation"),
				jsonObj.getInt("level"), 
				jsonObj.getBoolean("selected"),
				jsonObj.getBoolean("leaf")
				);
	}

	public String getId() {
		return id;
	}

	public String getName() {
		return name;
	}

	public String getIdGroup() {
		return idGroup;
	}

	public int getLevel() {
		return level;
	}

	public boolean isSelected() {
		return selected;
	}

	public boolean isLeaf() {
		return leaf;
	}

	public Collection<LocationRest> getLocations() {
		return locations;
	}

	public LocationRest getParent() {
		return parent;
	}
	
	public void setParent(LocationRest parent) {
		this.parent = parent;
	}

	@Override
	public String toString() {
		return "LocationRest [id=" + id + ", name=" + name + ", idGroup="
				+ idGroup + ", urlLocation=" + urlLocation + ", level=" + level + ", selected="
				+ selected + ", leaf=" + leaf + ", locations=" + locations
				+ "]";
	}

	public String getUrlLocation() {
		return urlLocation;
	}

}
