package com.oferteo.api.v1.client.rest;

import java.util.Locale;

public class MainCitiesHtmlBuilder extends HtmlBuilder 
{
	
	private String selectedCategoryUrl;
	private String urlPrefix;
	private boolean addLabel;
	private Locale locale;

	
	public MainCitiesHtmlBuilder(String selectedCategoryUrl, String urlPrefix, boolean addLabel, Locale locale) 
	{
		this.selectedCategoryUrl = selectedCategoryUrl;
		this.urlPrefix = urlPrefix;
		this.addLabel = addLabel;
		this.locale = locale;
	}
	
	public String getHtml() {
		addMainLocations();
		return getSb().toString();
	}
	
	private void addLabel()
	{
		getSb().append("<h2>").append(ApiClientUtils.getMessage(locale, "rfp.search.search.largeCities")).append("</h2>");
	}

	private void addCityAnchor(String cityName, String cityUrl) 
	{
		String categoryUrl = "";
		if (this.selectedCategoryUrl != null) {
			categoryUrl = selectedCategoryUrl;
		}
		String url = this.urlPrefix + categoryUrl + cityUrl;
		openAnchor(null, cityName, url);
			getSb().append(cityName);
		closeAnchor();
	}
	
	private void addMainLocations() 
	{
		openDiv("location-link");
			if (this.addLabel) {
				addLabel();
			}
	
			addCityAnchor("Cała Polska", "/polska");
			addCityAnchor("Warszawa", "/warszawa");
			addCityAnchor("Wrocław", "/wroclaw");
			addCityAnchor("Kraków", "/krakow");
			addCityAnchor("Poznań", "/poznan");
			addCityAnchor("Łódź", "/lodz");
			addCityAnchor("Gdańsk", "/gdansk");
			addCityAnchor("Szczecin", "/szczecin");
			addCityAnchor("Katowice", "/katowice");
			addCityAnchor("Bydgoszcz", "/bydgoszcz");
			addCityAnchor("Lublin", "/lublin");
			addCityAnchor("Bielsko-Biała", "/bielsko-biala");
			addCityAnchor("Częstochowa", "/czestochowa");
			addCityAnchor("Rzeszów", "/rzeszow");
			addCityAnchor("Białystok", "/bialystok");
			addCityAnchor("Gliwice", "/gliwice");
			addCityAnchor("Sosnowiec", "/sosnowiec");
			addCityAnchor("Kielce", "/kielce");
			addCityAnchor("Gdynia", "/gdynia");
			addCityAnchor("Toruń", "/torun");
			addCityAnchor("Radom", "/radom");
			
		closeDiv();//location-link
	}	

}
