package com.oferteo.api.v1.client.rest;

import java.util.Locale;

public class RfpHtmlBuilder extends HtmlBuilder 
{

	private RfpRest rfp;
	private String urlPrefix;
	private Locale locale;
	private String widgetId;

	public RfpHtmlBuilder(RfpRest rfp, String urlPrefix, Locale locale, String widgetId) 
	{
		super();
		this.rfp = rfp;
		this.urlPrefix = urlPrefix;
		this.locale = locale;
		this.widgetId = widgetId;
	}
	
	public String getHtml() 
	{
		openDiv("infobox");
			openDiv("info-header");
			
				openDiv("id-info");
					openSpan();
					getSb().append(ApiClientUtils.getMessage(locale, "rfp.details.number")).append(rfp.getRfpId());
					closeSpan();
					
					openAnchor("powered-by", ApiClientUtils.getMessage(locale, "rfp.search.poweredby"), "http://www.oferteo.pl");
						getSb().append("<img src=\"http://www.oferteo.pl/images/forms/dzial-zlecen/powered-by-2.png\" alt=\"").append(ApiClientUtils.getMessage(locale, "rfp.search.poweredby")).append("\" />");
					closeAnchor();
				closeDiv();
				
				if (widgetId != null && !widgetId.equals("")) {
					getSb().append("<style type='text/css'> .w-1 { width:100%; height:58px; } </style>");
					getSb().append("<div class='w-1 ").append(widgetId).append("'></div>");
				} else {
					openAnchor("btn btn-success", rfp.getCategoryName() + "&nbsp;-&nbsp;" + ApiClientUtils.getMessage(locale, "rfp.details.button.add.rfp.title"), rfp.getFormUrl());
					getSb().append(ApiClientUtils.getMessage(locale, "rfp.details.button.add.rfp.anchor"));
					closeAnchor();
					addDivClear();
				}
				getSb().append("<h1>");
				getSb().append(rfp.getTitle());
				getSb().append("</h1>");
			closeDiv();
			
			openDiv("line-grey");
			closeDiv();
			
			openDiv("info-main");
				openDiv("info-main-data");
					openDiv("info-main-data-label");
					getSb().append(ApiClientUtils.getMessage(locale, "rfp.details.category"));
					closeDiv();
					openDiv("info-main-data-value");
					getSb().append(rfp.getCategoryName());
					closeDiv();
					if (rfp.getSrcCountry() != null && rfp.getSrcCountry().isEmpty() == false) {
						openDiv("info-main-data-label");
						getSb().append(ApiClientUtils.getMessage(locale, "rfp.details.src.country"));
						closeDiv();
						openDiv("info-main-data-value");
						getSb().append(rfp.getSrcCountry()).append("&nbsp;").append(rfp.getSrcCity());
						closeDiv();
					}
					if (rfp.getDstCountry() != null && rfp.getDstCountry().isEmpty() == false) {
						openDiv("info-main-data-label");
						if (rfp.getSrcCountry() != null && rfp.getSrcCountry().isEmpty() == false) {
							getSb().append(ApiClientUtils.getMessage(locale, "rfp.details.dst.country"));
						} else {
							getSb().append(ApiClientUtils.getMessage(locale, "rfp.details.dst.region"));
						} 
						closeDiv();
						openDiv("info-main-data-value");
						getSb().append(rfp.getDstCountry()).append("&nbsp;").append(rfp.getDstVoivodship()).append("&nbsp;").append(rfp.getDstCity());
						closeDiv();
					}
					openDiv("info-main-data-label");
					getSb().append(ApiClientUtils.getMessage(locale, "rfp.details.subject"));
					closeDiv();
					
					boolean active = rfp.isActive();
					boolean individual = rfp.isIndividual();
					String iconCssClass = "";
					if (individual) {
						if (active) {
							iconCssClass = "icon-individual-person-active";
						} else {
							iconCssClass ="icon-individual-person-inactive";
						}
					} else {
						if (active) {
							iconCssClass = "icon-company-active";
						} else {
							iconCssClass = "icon-company-inactive";
						}
					}

					openDiv("info-main-data-value");
					if (rfp.isIndividual()) {
						openDiv("", ApiClientUtils.getMessage(locale, "rfp.details.subject.person.title"));closeDiv();
						getSb().append(ApiClientUtils.getMessage(locale, "rfp.details.subject.person"));
					} else {
						openDiv("", ApiClientUtils.getMessage(locale, "rfp.details.subject.company.title"));closeDiv();
						getSb().append(ApiClientUtils.getMessage(locale, "rfp.details.subject.company"));
					}
					closeDiv();
				closeDiv();
				
				openDiv("info-main-date");
					openSpan();
					getSb().append(rfp.getActivationTimeStr()).append(ApiClientUtils.getMessage(locale, "rfp.search.rfp.fromTo")).append(rfp.getExpirationTimeStr());
					closeSpan();
					openSpan();
					getSb().append(ApiClientUtils.getMessage(locale, "rfp.details.date.added"));
					getSb().append(rfp.getActivationPeriod());
					closeSpan();
				closeDiv();
				addDivClear();
				
				openDiv("info-content");
					openDiv("info-content-text");
					getSb().append(ApiClientUtils.replaceNewLinesToHTML(rfp.getDescription()));
					closeDiv();
					
					getSb().append("<form style=\"display: inline\" method=\"POST\" action=\"").append(rfp.getUncoverUrl()).append("\">");
					getSb().append("<input type=\"hidden\" name=\"doUncover\" value=\"true\">");
					getSb().append("<input type=\"hidden\" name=\"oc\" value=\"PP_").append(rfp.getOc()).append("\">");
					getSb().append("<input type=\"hidden\" name=\"rfpId\" value=\"").append(rfp.getRfpId()).append("\">");
					getSb().append("<button type=\"submit\" class=\"btn btn-primary\">").append(ApiClientUtils.getMessage(locale, "rfp.details.button.uncover")).append("</button>");
					getSb().append("</form>");
					
					addDivClear();
				closeDiv();
				
				openDiv("cta-link");
					openAnchor("", ApiClientUtils.getMessage(locale, "rfp.details.button.similar.title"), rfp.getFormUrl());
					getSb().append(ApiClientUtils.getMessage(locale, "rfp.details.similar.uncover"));
					closeAnchor();
				closeDiv();
				
				openDiv("similar-offer");
					getSb().append("<h2>");
					getSb().append(ApiClientUtils.getMessage(locale, "rfp.details.similar.title"));
					getSb().append("</h2>");
				
					if (rfp.getSimilarRfps() != null) {
						for (RfpRest rSimilar : rfp.getSimilarRfps()) {
							openDiv("similar-offer-title");
							openAnchor("", rSimilar.getTitle(), this.urlPrefix + "/" + rSimilar.getRfpUrl());
							getSb().append(rSimilar.getTitle());
							closeAnchor();
							openSpan();
							getSb().append(rSimilar.getActivationPeriod());
							closeSpan();
							closeDiv();
						}
					}
				closeDiv();

				MainCitiesHtmlBuilder mainCitiesBuilder = new MainCitiesHtmlBuilder(this.rfp.getCategoryUrl(), this.urlPrefix, true, getLocale());
				getSb().append(mainCitiesBuilder.getHtml());
			closeDiv();

		closeDiv();
		
		
		return getSb().toString();
	}

	protected RfpRest getRfp()
	{
		return rfp;
	}

	protected String getUrlPrefix()
	{
		return urlPrefix;
	}

	protected Locale getLocale()
	{
		return locale;
	}

	protected String getWidgetId()
	{
		return widgetId;
	}

}
