package com.oferteo.api.v1.client.rest;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.ResourceBundle;

import org.json.JSONArray;
import org.json.JSONObject;

public class RfpRest 
{

	private long 	rfpId;
	private String 	rfpUrl = "";
	private String 	formUrl = "";
	private String 	title = "";
	private String 	description = "";
	private int		categoryId;
	private String 	categoryName = "";
	private long	offersCounter;
	private String 	dstCountry;
	private String 	dstCountryId;
	private String 	dstVoivodship;
	private String 	dstVoivodshipId;
	private String	dstVoivodshipUrl;
	private String 	dstCity;
	private String  dstPoviat;
	private String  dstPoviatUrl;
	private String 	srcCountry;
	private String 	srcCountryId;
	private String 	srcCity;
	private long 	activationTime;
	private String 	activationPeriod = "";
	private long 	expirationTime;
	private String 	expirationPeriod = "";
	private String 	expirationPeriodStyle = "";
	private boolean isActive;
	private long 	requestTime;
	private long 	lastModifiedTime;
	private long 	allRfpsCounter;
	private boolean  individual;
	private String	categoryUrl;
	private String	uncoverUrl;
	private String	oc;
	private boolean accessible;
	
	private List<RfpRest> similarRfps = new ArrayList<RfpRest>();
	private Locale locale;
	
	protected RfpRest(long rfpId, String rfpUrl, String formUrl, String title,
			String description, int categoryId, String categoryName,
			long offersCounter, String dstCountry, String dstCountryId,
			String dstVoivodship, String dstVoivodshipId, String dstVoivodshipUrl, String dstCity,  String  dstPoviat, String  dstPoviatUrl,
			String srcCountry, String srcCountryId, String srcCity,
			long activationTime, String activationPeriod, long expirationTime,
			String expirationPeriod, String expirationPeriodStyle , boolean isActive, long requestTime,
			long lastModifiedTime, long allRfpsCounter, boolean  individual, String categoryUrl, JSONArray similarRfps, String uncoverUrl, String oc,
			boolean accessible) 
	{
		super();
		this.rfpId = rfpId;
		this.rfpUrl = rfpUrl;
		this.formUrl = formUrl;
		this.title = title;
		this.description = description;
		this.categoryId = categoryId;
		this.categoryName = categoryName;
		this.offersCounter = offersCounter;
		this.dstCountry = dstCountry;
		this.dstCountryId = dstCountryId;
		this.dstVoivodship = dstVoivodship;
		this.dstVoivodshipId = dstVoivodshipId;
		this.dstVoivodshipUrl = dstVoivodshipUrl;
		this.dstCity = dstCity;
		this.dstPoviat = dstPoviat;
		this.dstPoviatUrl = dstPoviatUrl;
		this.srcCountry = srcCountry;
		this.srcCountryId = srcCountryId;
		this.srcCity = srcCity;
		this.activationTime = activationTime;
		this.activationPeriod = activationPeriod;
		this.expirationTime = expirationTime;
		this.expirationPeriod = expirationPeriod;
		this.expirationPeriodStyle = expirationPeriodStyle;
		this.isActive = isActive;
		this.requestTime = requestTime;
		this.lastModifiedTime = lastModifiedTime;
		this.allRfpsCounter = allRfpsCounter;
		this.individual = individual;
		this.categoryUrl = categoryUrl;
		this.uncoverUrl = uncoverUrl;
		this.oc = oc;
		this.accessible = accessible;
		
		if (similarRfps != null) {
			for (int i = 0; i < similarRfps.length(); i++) {
			    JSONObject r = similarRfps.getJSONObject(i);
			    this.similarRfps.add(new RfpRest(r, locale));
			}
		}
	}
	
	public String getActivationTimeStr() {
		return ApiClientUtils.getDateStr(this.activationTime);
	}
	
	public String getExpirationTimeStr() {
		return ApiClientUtils.getDateStr(this.expirationTime);
	}
	
	public String getRequestTimeStr() {
		return ApiClientUtils.getDateStr(this.requestTime);
	}
	
	public String getLastModifiedTimeStr() {
		return ApiClientUtils.getDateStr(this.lastModifiedTime);
	}

	public RfpRest(JSONObject jsonObj, Locale locale) 
	{
		
		this(
				jsonObj.getLong("rfpId"), 
				jsonObj.getString("rfpUrl"), 
				jsonObj.getString("formUrl"), 
				jsonObj.getString("title"), 
				jsonObj.getString("description"), 
				jsonObj.getInt("categoryId"), 
				jsonObj.getString("categoryName"), 
				jsonObj.getLong("offersCounter"), 
				jsonObj.getString("dstCountry"), 
				jsonObj.getString("dstCountryId"), 
				jsonObj.getString("dstVoivodship"), 
				jsonObj.getString("dstVoivodshipId"), 
				jsonObj.getString("dstVoivodshipUrl"),
				jsonObj.getString("dstCity"), 
				jsonObj.getString("dstPoviat"), 
				jsonObj.getString("dstPoviatUrl"), 
				jsonObj.getString("srcCountry"), 
				jsonObj.getString("srcCountryId"), 
				jsonObj.getString("srcCity"), 
				jsonObj.getLong("activationTime"), 
				jsonObj.getString("activationPeriod"), 
				jsonObj.getLong("expirationTime"), 
				jsonObj.getString("expirationPeriod"), 
				jsonObj.getString("expirationPeriodStyle"), 
				jsonObj.getBoolean("active"), 
				jsonObj.getLong("requestTime"), 
				jsonObj.getLong("lastModifiedTime"), 
				jsonObj.getLong("allRfpsCounter"),
				jsonObj.getBoolean("individual"),
				jsonObj.getString("categoryUrl"),
				jsonObj.getJSONArray("similarRfps"),
				jsonObj.getString("uncoverUrl"),
				jsonObj.getString("oc"),
				jsonObj.getBoolean("accessible")
			);
		this.locale = locale;
	}
	
	public long getRfpId() {
		return rfpId;
	}

	public String getRfpUrl() {
		return rfpUrl;
	}

	public String getFormUrl() {
		return formUrl;
	}

	public String getTitle() {
		return title;
	}

	public String getDescription() {
		return description;
	}

	public int getCategoryId() {
		return categoryId;
	}

	public String getCategoryName() {
		return categoryName;
	}

	public long getOffersCounter() {
		return offersCounter;
	}

	public String getDstCountry() {
		return dstCountry;
	}

	public String getDstCountryId() {
		return dstCountryId;
	}

	public String getDstVoivodship() {
		return dstVoivodship;
	}

	public String getDstVoivodshipId() {
		return dstVoivodshipId;
	}

	public String getDstCity() {
		return dstCity;
	}

	public String getSrcCountry() {
		return srcCountry;
	}

	public String getSrcCountryId() {
		return srcCountryId;
	}

	public String getSrcCity() {
		return srcCity;
	}

	public long getActivationTime() {
		return activationTime;
	}

	public String getActivationPeriod() {
		return activationPeriod;
	}

	public long getExpirationTime() {
		return expirationTime;
	}

	public String getExpirationPeriod() {
		return expirationPeriod;
	}

	public boolean isActive() {
		return isActive;
	}

	public long getRequestTime() {
		return requestTime;
	}

	public long getLastModifiedTime() {
		return lastModifiedTime;
	}

	public long getAllRfpsCounter() {
		return allRfpsCounter;
	}

	@Override
	public String toString() {
		return "RfpRest [rfpId=" + rfpId + ", rfpUrl=" + rfpUrl + ", formUrl="
				+ formUrl + ", title=" + title + ", description=" + description
				+ ", categoryId=" + categoryId + ", categoryName="
				+ categoryName + ", offersCounter=" + offersCounter
				+ ", dstCountry=" + dstCountry + ", dstCountryId="
				+ dstCountryId + ", dstVoivodship=" + dstVoivodship
				+ ", dstVoivodshipId=" + dstVoivodshipId + ", dstCity="
				+ dstCity + ", srcCountry=" + srcCountry + ", srcCountryId="
				+ srcCountryId + ", srcCity=" + srcCity + ", activationTime="
				+ activationTime + ", activationPeriod=" + activationPeriod
				+ ", expirationTime=" + expirationTime + ", expirationPeriod="
				+ expirationPeriod + ", isActive=" + isActive
				+ ", requestTime=" + requestTime + ", lastModifiedTime="
				+ lastModifiedTime + ", allRfpsCounter=" + allRfpsCounter + "]";
	}


	public List<RfpRest> getSimilarRfps() {
		return similarRfps;
	}
	
	public String getIconClass() {
		if (this.individual) {
			if (this.isActive) {
				return "icon-individual-person pngfix icon-individual-person-active";
			} else {
				return "icon-individual-person pngfix icon-individual-person-inactive";
			}
		} else {
			if (this.isActive) {
				return "icon-company pngfix icon-company-active";
			} else {
				return "icon-company pngfix icon-company-inactive";
			}
		}
	}

	public String getRfpIconTitle() {
		ResourceBundle rb = ResourceBundle.getBundle("OferteoApi", locale);
		String key = "";
		if (isActive) {
			if (isIndividual()) {
				key = "rfp.title.personal.active";
			} else {
				key = "rfp.title.company.active";
			}
		} else {
			if (isIndividual()) {
				key = "rfp.title.personal.inactive";
			} else {
				key = "rfp.title.company.inactive";
			}
		}
		return rb.getString(key);
	}

	public boolean isIndividual() {
		return individual;
	}

	public String getCategoryUrl() {
		return categoryUrl;
	}

	public String getDstVoivodshipUrl() {
		return dstVoivodshipUrl;
	}

	public String getExpirationPeriodStyle() {
		return expirationPeriodStyle;
	}

	public void setExpirationPeriodStyle(String expirationPeriodStyle) {
		this.expirationPeriodStyle = expirationPeriodStyle;
	}

	public String getUncoverUrl() {
		return uncoverUrl;
	}

	public String getOc() {
		return oc;
	}

	public String getDstPoviat()
	{
		return dstPoviat;
	}

	public String getDstPoviatUrl()
	{
		return dstPoviatUrl;
	}

	public boolean isAccessible()
	{
		return accessible;
	}

}
