package com.oferteo.api.v1.client.rest;

import java.util.Locale;

public class RfpSingleColumnHtmlBuilder extends RfpHtmlBuilder 
{

	private CategoriesHtmlBuilder categoriesBuilder;
	private LocationsHtmlBuilder locationsBuilder;

	public RfpSingleColumnHtmlBuilder(RfpRest rfp, CategoriesHtmlBuilder categoriesBuilder, LocationsHtmlBuilder locationsBuilder, String urlPrefix, Locale locale, String widgetId) 
	{
		super(rfp, urlPrefix, locale, widgetId);
		this.categoriesBuilder = categoriesBuilder;
		this.locationsBuilder = locationsBuilder;
	}
	
	public String getHtml() 
	{
		openDiv("infobox");
			openDiv("info-header");

				openDiv("id-info");
					openSpan();
						getSb().append(ApiClientUtils.getMessage(getLocale(), "rfp.details.number")).append(getRfp().getRfpId());
					closeSpan();
					
					openAnchor("powered-by", ApiClientUtils.getMessage(getLocale(), "rfp.search.poweredby"), "http://www.oferteo.pl");
						getSb().append("<img src=\"http://www.oferteo.pl/images/forms/dzial-zlecen/powered-by-2.png\" alt=\"").append(ApiClientUtils.getMessage(getLocale(), "rfp.search.poweredby")).append("\" />");
					closeAnchor();
				closeDiv();
		
				if (getWidgetId() != null && !getWidgetId().equals("")) {
					getSb().append("<div id='").append(getWidgetId()).append("'></div>");
				} else {
					openAnchor("btn btn-success", getRfp().getCategoryName() + "&nbsp;-&nbsp;" + ApiClientUtils.getMessage(getLocale(), "rfp.details.button.add.rfp.title"), getRfp().getFormUrl());
					getSb().append(ApiClientUtils.getMessage(getLocale(), "rfp.details.button.add.rfp.anchor"));
					closeAnchor();
					addDivClear();
				}				
				getSb().append("<h1>");
				getSb().append(getRfp().getTitle());
				getSb().append("</h1>");
			closeDiv();
			
			openDiv("line-grey");
			closeDiv();
			
			openDiv("info-main");
				if (getRfp().isAccessible()) {
					openDiv("info-main-data");
						openDiv("info-main-data-label");
						getSb().append(ApiClientUtils.getMessage(getLocale(), "rfp.details.category"));
						closeDiv();
						openDiv("info-main-data-value");
						getSb().append(getRfp().getCategoryName());
						closeDiv();
						if (getRfp().getSrcCountry() != null && getRfp().getSrcCountry().isEmpty() == false) {
							openDiv("info-main-data-label");
							getSb().append(ApiClientUtils.getMessage(getLocale(), "rfp.details.src.country"));
							closeDiv();
							openDiv("info-main-data-value");
							getSb().append(getRfp().getSrcCountry()).append("&nbsp;").append(getRfp().getSrcCity());
							closeDiv();
						}
						if (getRfp().getDstCountry() != null && getRfp().getDstCountry().isEmpty() == false) {
							openDiv("info-main-data-label");
							if (getRfp().getSrcCountry() != null && getRfp().getSrcCountry().isEmpty() == false) {
								getSb().append(ApiClientUtils.getMessage(getLocale(), "rfp.details.dst.country"));
							} else {
								getSb().append(ApiClientUtils.getMessage(getLocale(), "rfp.details.dst.region"));
							} 
							closeDiv();
							openDiv("info-main-data-value");
							getSb().append(getRfp().getDstCountry()).append("&nbsp;").append(getRfp().getDstVoivodship()).append("&nbsp;").append(getRfp().getDstCity());
							closeDiv();
						}
						openDiv("info-main-data-label");
						getSb().append(ApiClientUtils.getMessage(getLocale(), "rfp.details.subject"));
						closeDiv();
						
						boolean active = getRfp().isActive();
						boolean individual = getRfp().isIndividual();
						String iconCssClass = "";
						if (individual) {
							if (active) {
								iconCssClass = "icon-individual-person-active";
							} else {
								iconCssClass ="icon-individual-person-inactive";
							}
						} else {
							if (active) {
								iconCssClass = "icon-company-active";
							} else {
								iconCssClass = "icon-company-inactive";
							}
						}
	
						openDiv("info-main-data-value");
						if (getRfp().isIndividual()) {
							openDiv("", ApiClientUtils.getMessage(getLocale(), "rfp.details.subject.person.title"));closeDiv();
							getSb().append(ApiClientUtils.getMessage(getLocale(), "rfp.details.subject.person"));
						} else {
							openDiv("", ApiClientUtils.getMessage(getLocale(), "rfp.details.subject.company.title"));closeDiv();
							getSb().append(ApiClientUtils.getMessage(getLocale(), "rfp.details.subject.company"));
						}
						closeDiv();
					closeDiv();
				
					openDiv("info-main-date");
						openSpan();
							getSb().append(getRfp().getActivationTimeStr()).append(ApiClientUtils.getMessage(getLocale(), "rfp.search.rfp.fromTo")).append(getRfp().getExpirationTimeStr());	
						closeSpan();
						openSpan();
							getSb().append(ApiClientUtils.getMessage(getLocale(), "rfp.details.date.added"));
							getSb().append(getRfp().getActivationPeriod());
						closeSpan();
					closeDiv();
				}
				addDivClear();
				
				openDiv("info-content");
					openDiv("info-content-text");
						getSb().append(ApiClientUtils.replaceNewLinesToHTML(getRfp().getDescription()));
					closeDiv();
					
					if (getRfp().isAccessible()) {
						getSb().append("<form style=\"display: inline\" method=\"POST\" action=\"").append(getRfp().getUncoverUrl()).append("\">");
						getSb().append("<input type=\"hidden\" name=\"doUncover\" value=\"true\">");
						getSb().append("<input type=\"hidden\" name=\"oc\" value=\"PP_").append(getRfp().getOc()).append("\">");
						getSb().append("<input type=\"hidden\" name=\"rfpId\" value=\"").append(getRfp().getRfpId()).append("\">");
						getSb().append("<button type=\"submit\" class=\"btn btn-primary\">").append(ApiClientUtils.getMessage(getLocale(), "rfp.details.button.uncover")).append("</button>");
						getSb().append("</form>");
					}					
					addDivClear();
				closeDiv();
				
				openDiv("cta-link");
					openAnchor("", ApiClientUtils.getMessage(getLocale(), "rfp.details.button.similar.title"), getRfp().getFormUrl());
					getSb().append(ApiClientUtils.getMessage(getLocale(), "rfp.details.similar.uncover"));
					closeAnchor();
				closeDiv();
				
			closeDiv();
			addDivClear();

			addCategoriesAndLocations();
			addSimilarOffers();
			addMainCities();
			
		closeDiv();	//infobox
		
		
		return getSb().toString();
	}

	private void addCategoriesAndLocations()
	{
		openDiv("more-offers");
			getSb().append("<h2>").append(ApiClientUtils.getMessage(getLocale(), "rfp.search.search.more")).append("</h2>");
			openDiv("list-category");
				getSb().append(this.categoriesBuilder.getHtml());
			closeDiv();
			openDiv("list-location");
				getSb().append(this.locationsBuilder.getHtml());
			closeDiv();
		closeDiv();
	}

	private void addMainCities()
	{
		MainCitiesHtmlBuilder mainCitiesBuilder = new MainCitiesHtmlBuilder(this.getRfp().getCategoryUrl(), getUrlPrefix(), true, getLocale());
		getSb().append(mainCitiesBuilder.getHtml());
	}

	private void addSimilarOffers()
	{
		openDiv("similar-offer");
			getSb().append("<h2>");
			getSb().append(ApiClientUtils.getMessage(getLocale(), "rfp.details.similar.title"));
			getSb().append("</h2>");
		
			if (getRfp().getSimilarRfps() != null) {
				for (RfpRest rSimilar : getRfp().getSimilarRfps()) {
					openDiv("similar-offer-title");
						openAnchor("", rSimilar.getTitle(), getUrlPrefix() + "/" + rSimilar.getRfpUrl());
							getSb().append(ApiClientUtils.getShortedText(rSimilar.getTitle(), 75)).append("...");
						closeAnchor();
						openSpan();
							getSb().append(rSimilar.getActivationPeriod());
						closeSpan();
					closeDiv();
				}
			}
		closeDiv();//similar offers
	}

}
